unit ImageSizeDialog;

interface

uses NLib, NForm, NkvImage;

type
  TImageSizeDlg = class(TDialog)
    Image: TNkVImage;
    Width: Integer;
    Height: Integer;
    Update: Boolean;
    constructor Create; override;
    procedure Init(var FocusId: Integer); override;
    procedure Ok; override;
    procedure Change(Id: Integer); override;
  end;

implementation

{$I dialogid.inc}

function SIntDef(const S: string): Integer;
begin
  try
    Result := SInt(S);
  except
    on EValueError do Result := 0;
  end;
end;

constructor TImageSizeDlg.Create;
begin
  inherited;
  TemplateName := 'IMAGESIZEDIALOG';
end;

procedure TImageSizeDlg.Init(var FocusId: Integer);
begin
  inherited;
  Items[IDC_WIDTH].SetText(IStr(Width));
  Items[IDC_HEIGHT].SetText(IStr(Height));
  Select(IDC_WIDTH);
  FocusId := IDC_WIDTH;
end;

procedure TImageSizeDlg.Ok;
begin
  Width := SIntDef(Items[IDC_WIDTH].Text);
  Height := SIntDef(Items[IDC_HEIGHT].Text);
  Update := True;
end;

procedure TImageSizeDlg.Change(Id: Integer);
var
 w, h: Integer;
begin
  w := SIntDef(Items[IDC_WIDTH].Text);
  h := SIntDef(Items[IDC_HEIGHT].Text);
  case Id of
    IDC_WIDTH:
      if Items[IDC_WIDTH].Focused then
        Items[IDC_HEIGHT].SetText(IStr(Trunc(w*Image.Height/Image.Width + 0.5)));
    IDC_HEIGHT:
      if Items[IDC_HEIGHT].Focused then
        Items[IDC_WIDTH].SetText(IStr(Trunc(h*Image.Width/Image.Height + 0.5)));
  end;
end;

end.
